%if 0%{?rhel} <= 6
%global __python /usr/bin/python3.4
%else
%global __python /usr/bin/python3.6
%endif
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')
%define debug_package %{nil}
%define daemon_user monitor
Name: magellan
Version: %{op5version}
Release: %{op5release}
License: OP5 EULA
Vendor: OP5 AB
Url: http://www.op5.com
BuildRoot: %{_tmppath}/%{name}-%{version}
Summary: Autodiscovery service
Group: Applications/Internet
Prefix: /opt/magellan
Requires: rabbitmq-server
Requires: op5-monitor-user
%if 0%{?rhel} <= 6
Requires: mysql-server
Requires: python34
BuildRequires: python34
%else
Requires: mariadb-server
Requires: python36
BuildRequires: python36
%endif
Source: %{name}-%{version}.tar.gz
BuildArchitectures: noarch

%description
Autodiscovery service

%prep
%setup -q


%install
%{__rm} --recursive --force %{buildroot}
%{__mkdir} --parents --mode 755 %{buildroot}%{prefix}
# The dist has already been built in the ci_config pre step.
%{__tar} cvfz dist.tar.gz dist
%{__cp} dist.tar.gz %{buildroot}%{prefix}/dist.tar.gz
%{__cp} magellan.conf %{buildroot}%{prefix}/magellan.conf
%{__cp} create-db.sh %{buildroot}%{prefix}/create-db.sh
%{__cp} api-definition.md %{buildroot}%{prefix}/api-definition.md
%{__python} -m venv venv
venv/bin/pip install markdown2
venv/bin/markdown2 -x code-friendly api-definition.md > %{buildroot}%{prefix}/api-definition.html
%if 0%{?rhel} <= 6
%{__mkdir} --parents --mode 755 %{buildroot}%{_initddir}
%{__cp} magellan.init %{buildroot}%{_initddir}/magellan
%else
%{__mkdir} --parents --mode 755 %{buildroot}%{_unitdir}
%{__cp} magellan.service %{buildroot}%{_unitdir}/magellan.service
%endif


%post
# Set up virtual environment
cd %{prefix}
%{__rm} --recursive --force venv
%{__python} -m venv venv
%{__tar} xvfz dist.tar.gz
venv/bin/pip install -f dist --no-index magellan pyautodiscover
%{__rm} --recursive --force dist
%{__chown} -R %{daemon_user} %{prefix}

%if 0%{?rhel} <= 6
service mysqld start
chkconfig --add mysqld

%{prefix}/create-db.sh

service rabbitmq-server start
chkconfig --add rabbitmq-server

service magellan start
chkconfig --add magellan
%endif


%preun
# Delete the magellan service on EL6
%if 0%{?rhel} <= 6
chkconfig --del magellan
%else
%systemd_preun magellan.service
%endif

%postun
%if 0%{?rhel} <= 6
if [ $1 -eq 1 ] ; then
    service magellan condrestart
fi
%else
%systemd_postun_with_restart magellan.service
%endif


%files
%defattr(644,%daemon_user,root,755)
%{prefix}/dist.tar.gz
%{prefix}/api-definition.md
%{prefix}/api-definition.html
%attr(755, root, root) %{prefix}/create-db.sh
%config(noreplace) %{prefix}/magellan.conf
%if 0%{?rhel} <= 6
%config(noreplace) %attr(755, root, root) %{_initddir}/magellan
%else
%config(noreplace) %attr(664, root, root) %{_unitdir}/magellan.service
%endif


%clean
rm -rf %{buildroot}


%changelog
* Fri Feb 8 2019 Petter Nyström <pnystrom@op5.com>
- Package dependencies in install step to enable offline installation
* Tue Dec 4 2018 Petter Nyström <pnystrom@op5.com>
- Add the api-definition file
* Mon Nov 26 2018 Petter Nyström <pnystrom@op5.com>
- Adapt the install and start process on EL7 to best practices
* Thu May 3 2018 Petter Nyström <pnystrom@op5.com>
- Add EL6 support
* Thu Sep 28 2017 Mattias Ryrlén <mattiasr@op5.com>
- Initial build
